//---------------------------------------------------------
// QA Navigator suite
// Copyright  2003 - 2007 Ronald D. Grindle
//---------------------------------------------------------

using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Threading;
using System.Windows.Forms;
using System.Xml;

using RG.Basics;
using RG.SQL;
using RG.XMLDB;

using QN.Basics;
using QN.DataMiner;

namespace QN.Fixer
{

	/// <summary>
	/// QA Navigator suite
	/// Copyright  2003 - 2007 Ronald D. Grindle
	///
	/// Fix Management Facililty
	/// </summary>
	public class frmFixer : System.Windows.Forms.Form
	{

		#region MyMembers

		private bool m_FXLoaded;

		private FixSrcInfoLst m_FixSrcLst;

		private Ref2DocLst m_TRLst;

		private	FXSelPresets m_FXSelPresets;

		private QNDataMiner m_QNDM;
		private QNGUIservice m_GUIservice;
		private QNphrase m_QNphrase;
		private QNpresets m_Presets;
		private QNTools m_QNTools;

		private static SimpleLog m_Logger;

		private string m_DescUid;
		private string m_FxStat;
		private string m_FxLstUid;
		private string m_FxUid;
		private string m_IRUid;
		private string m_ReqUid;

		private string m_loadUID;
		
        private RGSQL2 m_DB;
		private XMLDB m_xDB;

		#endregion

		#region Window members

		private System.Windows.Forms.GroupBox grpInfo;
		private System.Windows.Forms.Label lblAssgnd;
		private System.Windows.Forms.TextBox txtDesc;
		private System.Windows.Forms.TextBox txtFctn;
		private System.Windows.Forms.Label lblFctn;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.Label lblAppl;
		private System.Windows.Forms.TextBox txtTitle;
		private System.Windows.Forms.TextBox txtOpenTime;
		private System.Windows.Forms.TextBox txtOpenDate;
		private System.Windows.Forms.Label lblOpened;
		private System.Windows.Forms.TextBox txtFixDate;
		private System.Windows.Forms.Label lblFixed;
		private System.Windows.Forms.TextBox txtAppl;
		private System.Windows.Forms.Label lblRelease;
		private System.Windows.Forms.TextBox txtRelease;
		private System.Windows.Forms.GroupBox grpProbDesc;
		private System.Windows.Forms.ListBox lstTR;
		private System.Windows.Forms.Label lblFixLst;
		private System.Windows.Forms.TextBox txtAssgn;
		private System.Windows.Forms.ListBox lstFixSrc;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.ContextMenu ctxtMenuPR;
		private System.Windows.Forms.MenuItem ctxtViewPR;
		private System.Windows.Forms.ContextMenu ctxtMenuSrcLst;
		private System.Windows.Forms.MenuItem ctxtShowVSS;
		private System.Windows.Forms.ComboBox comboLog;
		private System.Windows.Forms.ContextMenu ctxtMenuLog;
		private System.Windows.Forms.MenuItem ctxtLogEntry;
		private System.Windows.Forms.Label lblFixDesc;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuSave;
		private System.Windows.Forms.MenuItem menuOpen;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.Label lblTR;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.TextBox txtStatus;
		private System.Windows.Forms.TextBox txtMyStat;
		private System.Windows.Forms.MenuItem ctxtRemove;
		private System.Windows.Forms.MenuItem ctxtAddSrc;
		private System.Windows.Forms.Button butAction;
		private System.Windows.Forms.MenuItem menuDocu;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuPrint;
		private System.Windows.Forms.Label lblTestReq;
		private System.Windows.Forms.TextBox txtTestReqs;
		private System.Windows.Forms.Label lblInterRel;
		private System.Windows.Forms.TextBox txtInter;
		private System.Windows.Forms.TextBox txtFixTime;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		
		#endregion

		public frmFixer() {

			try {

				m_Logger = new SimpleLog( "Fixer" );

				// Erforderlich fr die Windows Form-Designeruntersttzung
				InitializeComponent();

				init();
			}
			catch( Exception e ) {
		
				handleExcp( e );
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
                m_DB.close();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmFixer));
			this.grpInfo = new System.Windows.Forms.GroupBox();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.txtFixDate = new System.Windows.Forms.TextBox();
			this.lblFixed = new System.Windows.Forms.Label();
			this.txtOpenTime = new System.Windows.Forms.TextBox();
			this.txtAssgn = new System.Windows.Forms.TextBox();
			this.lblAssgnd = new System.Windows.Forms.Label();
			this.txtOpenDate = new System.Windows.Forms.TextBox();
			this.lblOpened = new System.Windows.Forms.Label();
			this.txtDesc = new System.Windows.Forms.TextBox();
			this.lblFixDesc = new System.Windows.Forms.Label();
			this.grpProbDesc = new System.Windows.Forms.GroupBox();
			this.lblTR = new System.Windows.Forms.Label();
			this.txtRelease = new System.Windows.Forms.TextBox();
			this.lblRelease = new System.Windows.Forms.Label();
			this.txtAppl = new System.Windows.Forms.TextBox();
			this.txtFctn = new System.Windows.Forms.TextBox();
			this.lblFctn = new System.Windows.Forms.Label();
			this.lblTitle = new System.Windows.Forms.Label();
			this.lblAppl = new System.Windows.Forms.Label();
			this.txtTitle = new System.Windows.Forms.TextBox();
			this.lstTR = new System.Windows.Forms.ListBox();
			this.ctxtMenuPR = new System.Windows.Forms.ContextMenu();
			this.ctxtViewPR = new System.Windows.Forms.MenuItem();
			this.lblFixLst = new System.Windows.Forms.Label();
			this.lstFixSrc = new System.Windows.Forms.ListBox();
			this.ctxtMenuSrcLst = new System.Windows.Forms.ContextMenu();
			this.ctxtAddSrc = new System.Windows.Forms.MenuItem();
			this.ctxtShowVSS = new System.Windows.Forms.MenuItem();
			this.ctxtRemove = new System.Windows.Forms.MenuItem();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuOpen = new System.Windows.Forms.MenuItem();
			this.menuSave = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuPrint = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuDocu = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuAbout = new System.Windows.Forms.MenuItem();
			this.txtMyStat = new System.Windows.Forms.TextBox();
			this.comboLog = new System.Windows.Forms.ComboBox();
			this.ctxtMenuLog = new System.Windows.Forms.ContextMenu();
			this.ctxtLogEntry = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.butAction = new System.Windows.Forms.Button();
			this.lblTestReq = new System.Windows.Forms.Label();
			this.txtTestReqs = new System.Windows.Forms.TextBox();
			this.txtInter = new System.Windows.Forms.TextBox();
			this.lblInterRel = new System.Windows.Forms.Label();
			this.txtFixTime = new System.Windows.Forms.TextBox();
			this.grpInfo.SuspendLayout();
			this.grpProbDesc.SuspendLayout();
			this.SuspendLayout();
			// 
			// grpInfo
			// 
			this.grpInfo.Controls.Add(this.txtStatus);
			this.grpInfo.Controls.Add(this.lblStatus);
			this.grpInfo.Controls.Add(this.txtFixTime);
			this.grpInfo.Controls.Add(this.txtFixDate);
			this.grpInfo.Controls.Add(this.lblFixed);
			this.grpInfo.Controls.Add(this.txtOpenTime);
			this.grpInfo.Controls.Add(this.txtAssgn);
			this.grpInfo.Controls.Add(this.lblAssgnd);
			this.grpInfo.Controls.Add(this.txtOpenDate);
			this.grpInfo.Controls.Add(this.lblOpened);
			this.grpInfo.Location = new System.Drawing.Point(572, 4);
			this.grpInfo.Name = "grpInfo";
			this.grpInfo.Size = new System.Drawing.Size(180, 312);
			this.grpInfo.TabIndex = 1;
			this.grpInfo.TabStop = false;
			this.grpInfo.Text = "Info";
			// 
			// txtStatus
			// 
			this.txtStatus.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtStatus.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtStatus.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtStatus.Location = new System.Drawing.Point(32, 104);
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.ReadOnly = true;
			this.txtStatus.Size = new System.Drawing.Size(140, 23);
			this.txtStatus.TabIndex = 8;
			this.txtStatus.TabStop = false;
			this.txtStatus.Text = "status";
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblStatus.Location = new System.Drawing.Point(4, 80);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(84, 20);
			this.lblStatus.TabIndex = 7;
			this.lblStatus.Text = "Status";
			// 
			// txtFixDate
			// 
			this.txtFixDate.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtFixDate.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtFixDate.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtFixDate.Location = new System.Drawing.Point(32, 248);
			this.txtFixDate.Name = "txtFixDate";
			this.txtFixDate.ReadOnly = true;
			this.txtFixDate.Size = new System.Drawing.Size(88, 23);
			this.txtFixDate.TabIndex = 2;
			this.txtFixDate.TabStop = false;
			this.txtFixDate.Text = "2003-12-31";
			// 
			// lblFixed
			// 
			this.lblFixed.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFixed.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblFixed.Location = new System.Drawing.Point(4, 224);
			this.lblFixed.Name = "lblFixed";
			this.lblFixed.Size = new System.Drawing.Size(84, 20);
			this.lblFixed.TabIndex = 1;
			this.lblFixed.Text = "Fixed";
			// 
			// txtOpenTime
			// 
			this.txtOpenTime.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtOpenTime.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOpenTime.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtOpenTime.Location = new System.Drawing.Point(32, 192);
			this.txtOpenTime.Name = "txtOpenTime";
			this.txtOpenTime.ReadOnly = true;
			this.txtOpenTime.Size = new System.Drawing.Size(48, 23);
			this.txtOpenTime.TabIndex = 0;
			this.txtOpenTime.TabStop = false;
			this.txtOpenTime.Text = "02:59";
			// 
			// txtAssgn
			// 
			this.txtAssgn.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtAssgn.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtAssgn.ForeColor = System.Drawing.Color.Black;
			this.txtAssgn.Location = new System.Drawing.Point(32, 48);
			this.txtAssgn.Name = "txtAssgn";
			this.txtAssgn.Size = new System.Drawing.Size(140, 23);
			this.txtAssgn.TabIndex = 0;
			this.txtAssgn.TabStop = false;
			this.txtAssgn.Text = "xxx";
			// 
			// lblAssgnd
			// 
			this.lblAssgnd.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAssgnd.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblAssgnd.Location = new System.Drawing.Point(4, 24);
			this.lblAssgnd.Name = "lblAssgnd";
			this.lblAssgnd.Size = new System.Drawing.Size(84, 20);
			this.lblAssgnd.TabIndex = 0;
			this.lblAssgnd.Text = "Assignee";
			// 
			// txtOpenDate
			// 
			this.txtOpenDate.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtOpenDate.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOpenDate.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtOpenDate.Location = new System.Drawing.Point(32, 160);
			this.txtOpenDate.Name = "txtOpenDate";
			this.txtOpenDate.ReadOnly = true;
			this.txtOpenDate.Size = new System.Drawing.Size(88, 23);
			this.txtOpenDate.TabIndex = 0;
			this.txtOpenDate.TabStop = false;
			this.txtOpenDate.Text = "2003-22-33";
			// 
			// lblOpened
			// 
			this.lblOpened.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblOpened.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblOpened.Location = new System.Drawing.Point(4, 136);
			this.lblOpened.Name = "lblOpened";
			this.lblOpened.Size = new System.Drawing.Size(84, 20);
			this.lblOpened.TabIndex = 0;
			this.lblOpened.Text = "Opened";
			// 
			// txtDesc
			// 
			this.txtDesc.AcceptsReturn = true;
			this.txtDesc.AcceptsTab = true;
			this.txtDesc.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtDesc.Location = new System.Drawing.Point(8, 216);
			this.txtDesc.Multiline = true;
			this.txtDesc.Name = "txtDesc";
			this.txtDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtDesc.Size = new System.Drawing.Size(560, 76);
			this.txtDesc.TabIndex = 1;
			this.txtDesc.Text = "Description";
			this.txtDesc.DoubleClick += new System.EventHandler(this.txtDesc_DoubleClick);
			// 
			// lblFixDesc
			// 
			this.lblFixDesc.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFixDesc.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblFixDesc.Location = new System.Drawing.Point(8, 192);
			this.lblFixDesc.Name = "lblFixDesc";
			this.lblFixDesc.Size = new System.Drawing.Size(132, 20);
			this.lblFixDesc.TabIndex = 13;
			this.lblFixDesc.Text = "Fix Description";
			// 
			// grpProbDesc
			// 
			this.grpProbDesc.Controls.Add(this.lblTR);
			this.grpProbDesc.Controls.Add(this.txtRelease);
			this.grpProbDesc.Controls.Add(this.lblRelease);
			this.grpProbDesc.Controls.Add(this.txtAppl);
			this.grpProbDesc.Controls.Add(this.txtFctn);
			this.grpProbDesc.Controls.Add(this.lblFctn);
			this.grpProbDesc.Controls.Add(this.lblTitle);
			this.grpProbDesc.Controls.Add(this.lblAppl);
			this.grpProbDesc.Controls.Add(this.txtTitle);
			this.grpProbDesc.Controls.Add(this.lstTR);
			this.grpProbDesc.Location = new System.Drawing.Point(8, 4);
			this.grpProbDesc.Name = "grpProbDesc";
			this.grpProbDesc.Size = new System.Drawing.Size(560, 184);
			this.grpProbDesc.TabIndex = 15;
			this.grpProbDesc.TabStop = false;
			this.grpProbDesc.Text = "Problem";
			// 
			// lblTR
			// 
			this.lblTR.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTR.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblTR.Location = new System.Drawing.Point(4, 140);
			this.lblTR.Name = "lblTR";
			this.lblTR.Size = new System.Drawing.Size(88, 36);
			this.lblTR.TabIndex = 8;
			this.lblTR.Text = "Problem Report";
			// 
			// txtRelease
			// 
			this.txtRelease.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtRelease.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtRelease.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtRelease.Location = new System.Drawing.Point(92, 108);
			this.txtRelease.Name = "txtRelease";
			this.txtRelease.ReadOnly = true;
			this.txtRelease.Size = new System.Drawing.Size(200, 23);
			this.txtRelease.TabIndex = 7;
			this.txtRelease.TabStop = false;
			this.txtRelease.Text = "V00.00.000";
			// 
			// lblRelease
			// 
			this.lblRelease.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblRelease.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblRelease.Location = new System.Drawing.Point(4, 111);
			this.lblRelease.Name = "lblRelease";
			this.lblRelease.Size = new System.Drawing.Size(88, 21);
			this.lblRelease.TabIndex = 6;
			this.lblRelease.Text = "Release";
			// 
			// txtAppl
			// 
			this.txtAppl.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtAppl.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtAppl.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtAppl.Location = new System.Drawing.Point(92, 52);
			this.txtAppl.Name = "txtAppl";
			this.txtAppl.ReadOnly = true;
			this.txtAppl.Size = new System.Drawing.Size(464, 23);
			this.txtAppl.TabIndex = 5;
			this.txtAppl.TabStop = false;
			this.txtAppl.Text = "Appl";
			// 
			// txtFctn
			// 
			this.txtFctn.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtFctn.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtFctn.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtFctn.Location = new System.Drawing.Point(92, 80);
			this.txtFctn.Name = "txtFctn";
			this.txtFctn.ReadOnly = true;
			this.txtFctn.Size = new System.Drawing.Size(464, 23);
			this.txtFctn.TabIndex = 4;
			this.txtFctn.TabStop = false;
			this.txtFctn.Text = "Function";
			// 
			// lblFctn
			// 
			this.lblFctn.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFctn.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblFctn.Location = new System.Drawing.Point(4, 82);
			this.lblFctn.Name = "lblFctn";
			this.lblFctn.Size = new System.Drawing.Size(92, 22);
			this.lblFctn.TabIndex = 0;
			this.lblFctn.Text = "Function";
			// 
			// lblTitle
			// 
			this.lblTitle.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTitle.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblTitle.Location = new System.Drawing.Point(4, 28);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(88, 20);
			this.lblTitle.TabIndex = 0;
			this.lblTitle.Text = "Title";
			// 
			// lblAppl
			// 
			this.lblAppl.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAppl.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblAppl.Location = new System.Drawing.Point(4, 53);
			this.lblAppl.Name = "lblAppl";
			this.lblAppl.Size = new System.Drawing.Size(92, 23);
			this.lblAppl.TabIndex = 0;
			this.lblAppl.Text = "Application";
			// 
			// txtTitle
			// 
			this.txtTitle.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtTitle.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtTitle.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtTitle.Location = new System.Drawing.Point(92, 24);
			this.txtTitle.Name = "txtTitle";
			this.txtTitle.ReadOnly = true;
			this.txtTitle.Size = new System.Drawing.Size(464, 23);
			this.txtTitle.TabIndex = 1;
			this.txtTitle.TabStop = false;
			this.txtTitle.Text = "Title";
			// 
			// lstTR
			// 
			this.lstTR.BackColor = System.Drawing.Color.LightSteelBlue;
			this.lstTR.ContextMenu = this.ctxtMenuPR;
			this.lstTR.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lstTR.ForeColor = System.Drawing.SystemColors.WindowText;
			this.lstTR.ItemHeight = 17;
			this.lstTR.Location = new System.Drawing.Point(92, 136);
			this.lstTR.Name = "lstTR";
			this.lstTR.Size = new System.Drawing.Size(464, 38);
			this.lstTR.TabIndex = 16;
			this.lstTR.TabStop = false;
			// 
			// ctxtMenuPR
			// 
			this.ctxtMenuPR.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							 this.ctxtViewPR});
			this.ctxtMenuPR.Popup += new System.EventHandler(this.ctxtMenuPR_Popup);
			// 
			// ctxtViewPR
			// 
			this.ctxtViewPR.Index = 0;
			this.ctxtViewPR.Text = "View PR";
			this.ctxtViewPR.Click += new System.EventHandler(this.ctxtViewPR_Click);
			// 
			// lblFixLst
			// 
			this.lblFixLst.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFixLst.Location = new System.Drawing.Point(8, 416);
			this.lblFixLst.Name = "lblFixLst";
			this.lblFixLst.Size = new System.Drawing.Size(132, 20);
			this.lblFixLst.TabIndex = 17;
			this.lblFixLst.Text = "Fix List";
			// 
			// lstFixSrc
			// 
			this.lstFixSrc.ContextMenu = this.ctxtMenuSrcLst;
			this.lstFixSrc.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lstFixSrc.ItemHeight = 17;
			this.lstFixSrc.Location = new System.Drawing.Point(8, 440);
			this.lstFixSrc.Name = "lstFixSrc";
			this.lstFixSrc.Size = new System.Drawing.Size(744, 72);
			this.lstFixSrc.TabIndex = 2;
			// 
			// ctxtMenuSrcLst
			// 
			this.ctxtMenuSrcLst.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																									 this.ctxtAddSrc,
																																									 this.ctxtShowVSS,
																																									 this.ctxtRemove});
			this.ctxtMenuSrcLst.Popup += new System.EventHandler(this.ctxtMenuSrcLst_Popup);
			// 
			// ctxtAddSrc
			// 
			this.ctxtAddSrc.Index = 0;
			this.ctxtAddSrc.Text = "Add Source";
			this.ctxtAddSrc.Click += new System.EventHandler(this.ctxtAddSrc_Click);
			// 
			// ctxtShowVSS
			// 
			this.ctxtShowVSS.Index = 1;
			this.ctxtShowVSS.Text = "Show VSS";
			this.ctxtShowVSS.Visible = false;
			this.ctxtShowVSS.Click += new System.EventHandler(this.ctxtShowVSS_Click);
			// 
			// ctxtRemove
			// 
			this.ctxtRemove.Index = 2;
			this.ctxtRemove.Text = "Remove";
			this.ctxtRemove.Click += new System.EventHandler(this.ctxtRemove_Click);
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.menuFile,
																																						 this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.menuOpen,
																																						 this.menuSave,
																																						 this.menuItem2,
																																						 this.menuPrint,
																																						 this.menuItem3,
																																						 this.menuExit});
			this.menuFile.Text = "File";
			this.menuFile.Click += new System.EventHandler(this.menuOpen_Click);
			// 
			// menuOpen
			// 
			this.menuOpen.Enabled = false;
			this.menuOpen.Index = 0;
			this.menuOpen.Text = "Open";
			this.menuOpen.Click += new System.EventHandler(this.menuOpen_Click);
			// 
			// menuSave
			// 
			this.menuSave.Enabled = false;
			this.menuSave.Index = 1;
			this.menuSave.Text = "Save";
			this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "-";
			// 
			// menuPrint
			// 
			this.menuPrint.Enabled = false;
			this.menuPrint.Index = 3;
			this.menuPrint.Text = "Print";
			this.menuPrint.Click += new System.EventHandler(this.menuPrint_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 4;
			this.menuItem3.Text = "-";
			// 
			// menuExit
			// 
			this.menuExit.Index = 5;
			this.menuExit.Text = "Exit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 1;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.menuDocu,
																																						 this.menuItem4,
																																						 this.menuAbout});
			this.menuHelp.Text = "Help";
			// 
			// menuDocu
			// 
			this.menuDocu.Index = 0;
			this.menuDocu.Text = "Docu";
			this.menuDocu.Click += new System.EventHandler(this.menuDocu_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.Text = "-";
			// 
			// menuAbout
			// 
			this.menuAbout.Index = 2;
			this.menuAbout.Text = "About";
			this.menuAbout.Click += new System.EventHandler(this.menuAbout_Click);
			// 
			// txtMyStat
			// 
			this.txtMyStat.BackColor = System.Drawing.Color.Yellow;
			this.txtMyStat.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtMyStat.Location = new System.Drawing.Point(8, 524);
			this.txtMyStat.Name = "txtMyStat";
			this.txtMyStat.ReadOnly = true;
			this.txtMyStat.TabIndex = 19;
			this.txtMyStat.TabStop = false;
			this.txtMyStat.Text = "Initializing...";
			this.txtMyStat.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// comboLog
			// 
			this.comboLog.ContextMenu = this.ctxtMenuLog;
			this.comboLog.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboLog.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.comboLog.ItemHeight = 17;
			this.comboLog.Location = new System.Drawing.Point(120, 524);
			this.comboLog.Name = "comboLog";
			this.comboLog.Size = new System.Drawing.Size(448, 25);
			this.comboLog.TabIndex = 20;
			this.comboLog.TabStop = false;
			// 
			// ctxtMenuLog
			// 
			this.ctxtMenuLog.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								this.ctxtLogEntry});
			this.ctxtMenuLog.RightToLeft = System.Windows.Forms.RightToLeft.No;
			// 
			// ctxtLogEntry
			// 
			this.ctxtLogEntry.Index = 0;
			this.ctxtLogEntry.Text = "Display Entry";
			this.ctxtLogEntry.Click += new System.EventHandler(this.ctxtLogEntry_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = -1;
			this.menuItem1.Text = "-";
			// 
			// butAction
			// 
			this.butAction.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.butAction.Location = new System.Drawing.Point(588, 524);
			this.butAction.Name = "butAction";
			this.butAction.Size = new System.Drawing.Size(152, 24);
			this.butAction.TabIndex = 21;
			this.butAction.Click += new System.EventHandler(this.butAction_Click);
			this.butAction.MouseEnter += new System.EventHandler(this.butAction_MouseEnter);
			this.butAction.MouseLeave += new System.EventHandler(this.butAction_MouseLeave);
			// 
			// lblTestReq
			// 
			this.lblTestReq.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTestReq.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblTestReq.Location = new System.Drawing.Point(8, 300);
			this.lblTestReq.Name = "lblTestReq";
			this.lblTestReq.Size = new System.Drawing.Size(132, 20);
			this.lblTestReq.TabIndex = 22;
			this.lblTestReq.Text = "test reqs";
			// 
			// txtTestReqs
			// 
			this.txtTestReqs.AcceptsReturn = true;
			this.txtTestReqs.AcceptsTab = true;
			this.txtTestReqs.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtTestReqs.Location = new System.Drawing.Point(8, 324);
			this.txtTestReqs.Multiline = true;
			this.txtTestReqs.Name = "txtTestReqs";
			this.txtTestReqs.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtTestReqs.Size = new System.Drawing.Size(744, 28);
			this.txtTestReqs.TabIndex = 23;
			this.txtTestReqs.Text = "";
			// 
			// txtInter
			// 
			this.txtInter.AcceptsReturn = true;
			this.txtInter.AcceptsTab = true;
			this.txtInter.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtInter.Location = new System.Drawing.Point(8, 380);
			this.txtInter.Multiline = true;
			this.txtInter.Name = "txtInter";
			this.txtInter.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtInter.Size = new System.Drawing.Size(744, 28);
			this.txtInter.TabIndex = 24;
			this.txtInter.Text = "";
			// 
			// lblInterRel
			// 
			this.lblInterRel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblInterRel.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.lblInterRel.Location = new System.Drawing.Point(8, 356);
			this.lblInterRel.Name = "lblInterRel";
			this.lblInterRel.Size = new System.Drawing.Size(132, 20);
			this.lblInterRel.TabIndex = 25;
			this.lblInterRel.Text = "interrelations";
			// 
			// txtFixTime
			// 
			this.txtFixTime.BackColor = System.Drawing.Color.LightSteelBlue;
			this.txtFixTime.Font = new System.Drawing.Font("Microsoft Sans Serif", 10.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtFixTime.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtFixTime.Location = new System.Drawing.Point(32, 280);
			this.txtFixTime.Name = "txtFixTime";
			this.txtFixTime.ReadOnly = true;
			this.txtFixTime.Size = new System.Drawing.Size(48, 23);
			this.txtFixTime.TabIndex = 3;
			this.txtFixTime.TabStop = false;
			this.txtFixTime.Text = "01:59";
			// 
			// frmFixer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(758, 554);
			this.Controls.Add(this.lblInterRel);
			this.Controls.Add(this.txtInter);
			this.Controls.Add(this.txtTestReqs);
			this.Controls.Add(this.txtMyStat);
			this.Controls.Add(this.txtDesc);
			this.Controls.Add(this.lblTestReq);
			this.Controls.Add(this.butAction);
			this.Controls.Add(this.comboLog);
			this.Controls.Add(this.lstFixSrc);
			this.Controls.Add(this.lblFixLst);
			this.Controls.Add(this.grpProbDesc);
			this.Controls.Add(this.lblFixDesc);
			this.Controls.Add(this.grpInfo);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Menu = this.mainMenu;
			this.Name = "frmFixer";
			this.Text = "Fix Processor";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmFixer_Closing);
			this.grpInfo.ResumeLayout(false);
			this.grpProbDesc.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmFixer());
		}

		#region Mystuff
		
		//-----------------------------------
		private void addLog( IRslt p_Res ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Res.getRsltLastMsg();

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( ref p_Res );

			comboLog.SelectedIndex = ix;
		}

		//-----------------------------------
		private void addLog( string p_Msg ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Msg;

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( msg );

			comboLog.SelectedIndex = ix;
		}

		//-------------------------------------------------------------------------					
		private RsltXMLNode bldFXdoc() {

			int i, x;
			
			FixSrcInfo fixSrc;

			Ref2Doc TR;

			RsltXMLNode aNode;
			RsltXMLNode bNode;
			RsltXMLNode FXNode;

			string dt;

			/*
				<!ELEMENT Fix (RefProbRep*, Desc?, TestReq?, InterRel?, FixLst, AddInfo*, LogEntry*)>
					<!ATTLIST Fix
						Appl					CDATA #IMPLIED
						Assignd				CDATA #IMPLIED
						DateTime			NMTOKEN #REQUIRED
						DateTimeFix		NMTOKEN #IMPLIED
						DateTimeShip	NMTOKEN #IMPLIED
						Fctn					CDATA #IMPLIED
						FixStat				(as|at|bd|cl|ct|es|ev|fx|qr|qt|re|rv|sh|tf|ts|wf) "as"
						LastMod				NMTOKEN #IMPLIED
						LastModBy			CDATA #IMPLIED
						Lock					NMTOKEN #IMPLIED
						PlanRel				NMTOKEN #IMPLIED
						ProbRel				NMTOKEN #IMPLIED
						ShipRel				NMTOKEN #IMPLIED
						Title					CDATA #REQUIRED
						UID						NMTOKEN #IMPLIED
					>
			*/

			string nodeName = "Fix";
			FXNode = new RsltXMLNode( nodeName );

			if( FXNode.isOK() ) {

				//<?xml version="1.0"?>
				FXNode.createXmlDecl( "1.0", "", "" );

				//<!DOCTYPE TestCase SYSTEM "RG.TestCaseV01.dtd">
				FXNode.addSysDocTypeInfo( nodeName, QNDefs.dtdNameFX );

				//<!-- Generated by QA Navigator Fix Proc... -->
				string genCom = QNDefs.phrGenBy + m_QNTools.getApplInfo();
				FXNode.addComment( genCom );

				FXNode.addUID( m_FxUid );

				FXNode.addAttribAsHtml( "Appl", txtAppl.Text );

				FXNode.addAttribAsHtml( "Assignd", txtAssgn.Text );

				dt = txtFixDate.Text + "T" + txtFixTime.Text;
				FXNode.addAttrib( "DateTimeFix", dt );

				//dt = txtShipDate.Text + "T" + txtShipTime.Text;
				//FXNode.addAttrib( "DateTimeShip", dt );

				dt = txtOpenDate.Text + "T" + txtOpenTime.Text;
				FXNode.addAttrib( "DateTime", dt );

				FXNode.addAttribAsHtml( "Fctn", txtFctn.Text );

				FXNode.addAttribAsHtml( "FixStat", m_FxStat );

				//FXNode.addAttribAsHtml( "PlanRel", txtTrgtRelease.Text );

				FXNode.addAttribAsHtml( "ProbRel", txtRelease.Text );

				//FXNode.addAttribAsHtml( "ShipRel", txtReleaseShpd.Text );

				FXNode.addAttribAsHtml( "Title", txtTitle.Text );
			}

			if( FXNode.isOK() ) {

				/*
					<!ELEMENT RefProbRep (EMPTY)>
						<!ATTLIST RefProbRep
							RefUID	NMTOKEN #REQUIRED
							Title		CDATA #REQUIRED
							UID			NMTOKEN #IMPLIED
						>
				*/

				//lstPrecTC.Items
				x = m_TRLst.Count;

				for( i = 0; i < x; ++i ) {

					TR = m_TRLst[ i ];

					aNode = FXNode.appNode( "RefProbRep" );

					aNode.addUID( TR.UID );

					aNode.addAttrib( "RefUID", TR.RefUID );

					aNode.addAttribAsHtml( "Title", TR.Title );
				}
			}

			if( FXNode.isOK() ) {
				
				if( txtDesc.Text.Length > 0 ) {

					aNode = FXNode.appTxtNodeAsHTML( "Desc", txtDesc.Text );
					aNode.addUID( m_DescUid );
				}
			}

			if( FXNode.isOK() ) {
				
				if( txtDesc.Text.Length > 0 ) {

					aNode = FXNode.appTxtNodeAsHTML( "TestReq", txtTestReqs.Text );
					aNode.addUID( m_ReqUid );
				}
			}

			if( FXNode.isOK() ) {
				
				if( txtDesc.Text.Length > 0 ) {

					aNode = FXNode.appTxtNodeAsHTML( "InterRel", txtInter.Text );
					aNode.addUID( m_IRUid );
				}
			}

			if( FXNode.isOK() ) {

			/*
				<!ELEMENT FixLst (FixEntry*)>
					<!ATTLIST FixLst
						UID				NMTOKEN #IMPLIED
					>
			*/					
				aNode = FXNode.appNode( "FixLst" );

				aNode.addUID( m_FxLstUid );

			/*
					<!ELEMENT FixEntry (EMPTY)>
						<!ATTLIST FixEntry
							DateTime	NMTOKEN #REQUIRED
							Name			NMTOKEN #REQUIRED
							Path			NMTOKEN #IMPLIED
							Rel				NMTOKEN #IMPLIED
							SrcSrv		NMTOKEN #IMPLIED
							UID				NMTOKEN #IMPLIED
						>
				*/

				x = m_FixSrcLst.Count;

				for( i = 0; i < x; ++i ) {

					fixSrc = m_FixSrcLst[ i ];
					 
					bNode = aNode.appNode( "FixEntry" );

					bNode.addUID( fixSrc.UID );

					bNode.addAttrib( "DateTime", fixSrc.m_DateTime );
					bNode.addAttribAsHtml( "Name", fixSrc.Title );
					bNode.addAttribAsHtml( "Path", fixSrc.m_Path );
					bNode.addAttribAsHtml( "Rel", fixSrc.m_Rel );
					bNode.addAttribAsHtml( "SrcSrv", fixSrc.m_Server );
				}
			}

			return FXNode;
		}

		//-----------------------------------
		private void handleExcp( Exception p_Excp ) {
			
			setAppStat( AppStat.Error );

			addLog( "Exception '" + p_Excp.Message + "'");

			m_Logger.write2Log( ref p_Excp );

			m_GUIservice.dispExcp( p_Excp );
		}

		//------------------------------------
		private void handleErr( IRslt p_Res, string p_Msg ) {

			setAppStat( AppStat.Error );

			m_Logger.write2Log( ref p_Res );

			addLog( p_Msg );

			issueErr( p_Msg );
		}

		//-----------------------
		private void handleIfErr( IRslt p_Res, string p_Msg ) {

			if( p_Res.notOK() ) {

				handleErr( p_Res, p_Msg );
			}
		}

		
		//-----------------------
		private void handleErrStat( IRslt p_Res, string p_Msg ) {

			if( p_Res.notOK() ) {

				handleErr( p_Res, p_Msg );
			}
			else {

				setAppStat( AppStat.OK );
			}
		}
		
		// -----------------------------
		/// <summary>
		/// Displays a text dialog. Detects, if the dialog is supposed to allow editing.
		/// If so, the Rslt is written back to p_Sender. 
		/// </summary>
		/// <param name="p_Sender"></param>
		/// <param name="p_Title"></param>
		private void handleTxtPop( object p_Sender, string p_Title ) {

			try {

				bool forEdit;
				DialogResult dRes;
				TextBox tBox;

				tBox = (TextBox)p_Sender;
				
				forEdit = !(tBox.ReadOnly);
			
				setAppStat( AppStat.Proc );

				frmTxtWin txtWin;
		
				txtWin = new frmTxtWin( forEdit, ref m_Presets );

				txtWin.Text = p_Title;

				txtWin.setText( tBox.Text );

				txtWin.TopMost = true;

				dRes = txtWin.ShowDialog();

				if( DialogResult.OK == dRes ) {

					if( forEdit ) {

						tBox.Text = txtWin.m_Text;
					}

					setAppStat( AppStat.OK );
				}

				txtWin.Dispose();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
				
				handleExcp( excp );
			}	
		}

		// -----------------------------------
		void handleFixDescDial( ref frmFixDesc p_dialFixDesc ) {

			FixSrcInfo fixSrcInf;

			string txt;

			DialogResult dRes = p_dialFixDesc.ShowDialog();

			if( DialogResult.Cancel == dRes ) {

				setAppStat( AppStat.OK );
			}
			else {

				fixSrcInf = p_dialFixDesc.m_FixInf;

				txt = fixSrcInf.m_Path + fixSrcInf.Title + " - V" + fixSrcInf.m_Rel + " - " + fixSrcInf.m_DateTime;

				lstFixSrc.Items.Add( txt );

				m_FixSrcLst.Add( fixSrcInf );

				setAppStat( AppStat.OK );
			}

			p_dialFixDesc.Dispose();
		}

		// -----------------------------------
		/*
		void handleVSSSelDial( ref frmVSSSel p_diaVSSSel ) {

			ArrayList RsltLst;
			string[] iInfo;

			FixSrcInfo fixSrcInf;

			int i, x;
			string txt;

			DialogResult dRes = p_diaVSSSel.ShowDialog();

			if( DialogResult.Cancel == dRes ) {

				setAppStat( AppStat.OK );
			}
			else {

				RsltLst = p_diaVSSSel.m_RsltLst;

				x = RsltLst.Count;

				for( i = 0; i < x; i++ ) {

					iInfo = (string[])RsltLst[i];

					//[n,0]: path, [n,1]: name, [n,2]: version number, [n,3]: date, [n,4]: time, [n,5]: user
					txt = iInfo[0] + iInfo[1] + " - V" + iInfo[2] + " - " + iInfo[3] + " " + iInfo[4] + " - " + iInfo[5];

					fixSrcInf = new FixSrcInfo( iInfo[1] );

					fixSrcInf.m_DateTime = iInfo[3] + "T" + iInfo[4];
					fixSrcInf.m_Path = iInfo[0];
					fixSrcInf.m_Rel = iInfo[2];
					fixSrcInf.m_Server = p_diaVSSSel.m_VSSDBPath;

/* 3.9.2005
					entry[0] = iInfo[0];
					entry[1] = iInfo[1];
					entry[2] = iInfo[2];
					entry[3] = iInfo[3];
					entry[4] = iInfo[4];
					entry[5] = p_diaVSSSel.m_VSSDBPath;
					entry[6] = "";
*
					lstFixSrc.Items.Add( txt );

					m_FixSrcLst.Add( fixSrcInf );
				}

				setAppStat( AppStat.OK );
			}

			p_diaVSSSel.Dispose();
		} */

		// -------------------------------
		void handleSelDial( ref frmFXSel p_dialFXSel ) {

			DatLstEntry entry;
			DataLst RsltLst;
			int x;

			DialogResult dRes = p_dialFXSel.ShowDialog();

			if( DialogResult.Cancel == dRes ) {

				setAppStat( AppStat.OK );
			}
			else {

				RsltLst = p_dialFXSel.m_RsltLst;

				x = RsltLst.Count;

				if( x > 0 ) {

					entry = RsltLst[0];
					/*
						m_txtWin = new frmDebug();
						m_txtWin.Text = m_QNphrase.lblException;
					*/
					m_loadUID = entry.val;

					loadFXloader();

					//Thread loadThread = new Thread(new ThreadStart(loadFXloader));

					// Start the thread.
					//loadThread.Start();
				}
			}

			p_dialFXSel.Dispose();
		}

		//  ---------------------------
		private void init() {
			frmFixer.CheckForIllegalCrossThreadCalls = false;
			Rslt res = new Rslt( true );

			m_QNTools = new QNTools();

			m_QNphrase = m_QNTools.m_QNphrase;

			m_GUIservice = new QNGUIservice( m_QNphrase );

			m_Presets = new QNpresets( m_QNTools );

			setClrs();

			m_Logger.write2Log( m_QNTools.getApplInfo() );

			setLabels();

			m_TRLst = new Ref2DocLst( "RefProbRep" );
			m_FixSrcLst = new FixSrcInfoLst();

			m_FXSelPresets = new FXSelPresets( m_QNTools );

			if( m_Presets.notOK() ) {

				res.setRsltStat( m_Presets, m_QNphrase.errPresetFrm );
			}
			else {
			
				setUpAppl();

                m_DB = new RGSQL2( m_Presets.m_DBloc, m_Presets.m_DBname, m_Presets.m_DBuser, m_Presets.m_DBpw );

				if( res.checkRslt( m_DB ) ) {

    				m_xDB = new XMLDB( m_DB, m_Presets.m_UIDsrvLoc );

					m_QNDM = new QNDataMiner( m_xDB );
				}

				reset();
			}

			if( res.notOK() ) {

				handleErr( res, m_QNphrase.errInitFailed );
			}
			else {

				setAppStat( AppStat.OK );

				menuOpen.Enabled = true;

				addLog( BTools.getNowISODate() + " " + m_QNphrase.msgSesStart );
			}
		}
			
		//-----------------------------------
		private void issueErr( string msg ) {

			MessageBox.Show( msg, m_QNphrase.lblErr, MessageBoxButtons.OK, MessageBoxIcon.Error );
		}

		//  ---------------------------
		private void reset() {

			m_FXLoaded = false;

			m_DescUid = "";
			m_FxStat = "";
			m_FxUid = "";
			m_FxLstUid = "";
			m_IRUid = "";
			m_ReqUid = "";
			
			m_FixSrcLst.Clear();
			m_TRLst.Clear();

			menuSave.Enabled = false;
			menuPrint.Enabled = false;

			txtAppl.Text = "";
			txtAssgn.Text = ""; 
			txtDesc.Text = "";
			txtFctn.Text = "";
			txtFixDate.Text = "";
			txtFixTime.Text = "";
			txtInter.Text = "";
			txtOpenDate.Text = "";
			txtOpenTime.Text = "";
			txtRelease.Text = "";
			//txtReleaseShpd.Text = "";
			//txtShipDate.Text = "";
			//txtShipTime.Text = "";
			txtStatus.Text = "";
			txtTestReqs.Text = "";
			txtTitle.Text = "";
			//txtTrgtRelease.Text = "";

			lstTR.Items.Clear();
			lstFixSrc.Items.Clear();

			m_FXSelPresets.m_Assgn = m_Presets.m_Author;
		}

		//--------------------------------
		private Rslt saveFix( ref string p_Stat ) {

			RsltXMLNode xNode;
			RsltString rUid;
			Rslt res = new Rslt( true );

			txtAssgn.Text = m_Presets.m_Author;

			xNode = bldFXdoc();

			if( !res.checkRslt( xNode ) ) {

				string msg = String.Format( m_QNphrase.errCrtngFailed, txtTitle.Text );
				res.addRsltAddInfo( msg );
			}
			else {

				rUid = m_xDB.importXML( ref xNode.m_xDoc );

				if( !res.checkRslt( rUid ) ) {

					res.addRsltAddInfo( m_QNphrase.errTCSaveFailed );

					m_xDB.resetRslt(); // old style;
				}
				else {

					m_FxUid = rUid.theString;

					addLog( String.Format( m_QNphrase.msgSaved, m_QNphrase.lblFix ) );
				}
			}	
	
			handleIfErr( res, "'saveFix( ... )' failed." );

			return res;
		}

		//--------------------------------
		private void setAppStat( AppStat p_Stat ) {

			switch( p_Stat) {

				case AppStat.OK:

					txtMyStat.BackColor = m_Presets.m_ClrStatOK;
					txtMyStat.ForeColor = Color.White;
					txtMyStat.Text = m_QNphrase.lblOK;
					break;

				case AppStat.Proc:

					txtMyStat.BackColor = m_Presets.m_ClrStatProc;
					txtMyStat.ForeColor = Color.Black;
					txtMyStat.Text = m_QNphrase.lblProcng;
					break;

				case AppStat.Error:

					txtMyStat.BackColor = m_Presets.m_ClrStatErr;
					txtMyStat.ForeColor = Color.White;
					txtMyStat.Text =  m_QNphrase.lblErr;
					break;
			}

			this.Refresh();			
		}

		//---------------------------------
		private void setAppStatOK( bool p_IsOK ) {

			if( p_IsOK ) {

				setAppStat( AppStat.OK );
			}
			else {

				setAppStat( AppStat.Error );
			}
		}

		//----------------------------------

		/// <summary>
		/// Also sets the save menu status.
		/// </summary>
		private void setButStat( ) {

			string butTxt = "";
			menuSave.Enabled = false; 

			/*
			as = assigned
			at = assigned for test
			bd = building
			cl = closed
			ct = customer test
			es = estimating
			ev = evaluating
			fx = fixing
			qr = queued for review
			qt = queued for test
			re = re-open
			rv = reviewing
			sh = shipped
			tf = test failed
			ts = testing
			wf = waiting for dep fix
			*/

			if( m_FxStat.CompareTo( "as" ) == 0  ) {

				butTxt = m_QNphrase.blblFix;
				menuSave.Enabled = true;
			}
			else {

				if( m_FxStat.CompareTo( "fx" ) == 0 ) {

					butTxt = m_QNphrase.blblQ4Tst;
					menuSave.Enabled = true;
				}
			}

			menuPrint.Enabled = true;

			butAction.Text = butTxt;
		}

		//-------------------------------------------------------------------------
		private void setClrs() {

			this.BackColor = m_Presets.m_ClrPnlBck;		
			this.ForeColor = m_Presets.m_ClrPnlFor;
				
			butAction.BackColor = m_Presets.m_ClrButBck;
			butAction.ForeColor = m_Presets.m_ClrPnlFor;

			comboLog.BackColor = m_Presets.m_ClrTxtBck;

			lstFixSrc.BackColor = m_Presets.m_ClrTxtBck;

			txtDesc.BackColor = m_Presets.m_ClrTxtBck;
			txtTestReqs.BackColor = m_Presets.m_ClrTxtBck;
			txtInter.BackColor = m_Presets.m_ClrTxtBck;
		}

		//----------------------------------
		private Rslt nextFixStat() {

			RsltString val;
			Rslt res = new Rslt( true );

			if( m_FxStat.CompareTo( "as" ) == 0  ) {
				
				m_FxStat = "fx";

				res = saveFix( ref m_FxStat );			
			}
			else {

				if( m_FxStat.CompareTo( "fx" ) == 0 ) {

					txtFixDate.Text = BTools.getNowISODate();
					txtFixTime.Text = BTools.getNowISOTime();
					m_FxStat = "rt";
				
					res = saveFix( ref m_FxStat );

					if( res.isOK() ) {
		
						val = setPRStat( ref m_FxStat );

						if( res.checkRslt( val ) ) {
		
							res = m_QNDM.assignFixBack( val.theString, ref m_Presets.m_Author );
						}
					}
				}
			}

			/*
			if( proc ) {

				txtTrgtRelease.BackColor = m_Presets.m_ClrTxtBck;
				txtTrgtRelease.ReadOnly = false;
			}
			else {

				txtTrgtRelease.BackColor = m_Presets.m_ClrTxtBckRO;
				txtTrgtRelease.ReadOnly = true;
			}
			*/
			
			if( res.isOK() ) {

				val = m_Presets.m_FixStatLst.getLabelByVal( m_FxStat );

				//------------------------ processing log
				//addDocLog( val );

				txtStatus.Text = val.theString;

				setButStat();
			}

			return res;
		}

		//----------------------------------
		private void setLabels() {

			Text = m_QNphrase.lblFixMgr;

			ctxtShowVSS.Text = m_QNphrase.mlblShowVSS;
      ctxtViewPR.Text = m_QNphrase.mlblViewPR;
			ctxtLogEntry.Text = m_QNphrase.mlblDispEntry;

			grpInfo.Text = m_QNphrase.lblInfo;
			grpProbDesc.Text = m_QNphrase.lblProbDesc;

			lblAssgnd.Text = m_QNphrase.lblAssgnd;
			lblAppl.Text = m_QNphrase.lblAppl;
			lblFixDesc.Text = m_QNphrase.lblFixDesc;
			lblFctn.Text = m_QNphrase.lblFctn;
			lblFixed.Text = m_QNphrase.lblFixed;
			lblFixLst.Text = m_QNphrase.lblFixLst;
			lblOpened.Text = m_QNphrase.lblOpened;
			lblTR.Text = m_QNphrase.lblTR10;
			lblRelease.Text = m_QNphrase.lblRelease;
			//lblReleaseShpd.Text = m_QNphrase.lblReleaseShpd;
			//lblShiped.Text = m_QNphrase.lblShiped;
			lblStatus.Text = m_QNphrase.lblStatus;
			lblTitle.Text = m_QNphrase.lblTitle;
			//lblTrgtRelease.Text = m_QNphrase.lblTrgtRelease;
			lblInterRel.Text = m_QNphrase.lblInterRel;
			lblTestReq.Text = m_QNphrase.lblTestReq;
			
/*
			menuDel.Text = m_QNphrase.mlblDel;
			menuExport.Text = m_QNphrase.mlblExp;
			menuImport.Text = m_QNphrase.mlblImp;
			menuNew.Text = m_QNphrase.mlblNew;
*/			
			menuAbout.Text = m_QNphrase.mlblAbout;
			menuDocu.Text = m_QNphrase.mlblDocu;
			menuExit.Text = m_QNphrase.mlblExit;
			menuFile.Text = m_QNphrase.mlblFile;
			menuHelp.Text = m_QNphrase.mlblHelp;
			menuOpen.Text = m_QNphrase.mlblOpen;
			menuPrint.Text = m_QNphrase.mlblPrint;
			menuSave.Text = m_QNphrase.mlblSave;

			ctxtAddSrc.Text = m_QNphrase.mlblAddSrc;
      ctxtLogEntry.Text = m_QNphrase.mlblDispEntry;
			ctxtRemove.Text = m_QNphrase.mlblRemove;
			ctxtShowVSS.Text = m_QNphrase.mlblShowVSS;
			ctxtViewPR.Text = m_QNphrase.mlblViewPR;
		}

		// ----------------------------------------------------
		private void setUpAppl() {

			txtAssgn.Text = m_Presets.m_Author;	
		}

		// ----------------------
		private RsltString setPRStat( ref string p_Sta ) {

			RsltString prUID = new RsltString();
			Rslt res;

			string msg;
			string uid;

			if( p_Sta.Length > 0 ) {

				prUID = m_QNDM.getPRUID4Fix( ref m_FxUid );

				if( prUID.isOK() ) {

					uid = prUID.theString;

					res = m_xDB.setAttrVal( uid , QNDefs.attrProbStat, p_Sta );

					if( prUID.checkRslt( res ) ) {

						msg = String.Format( m_QNphrase.msgStatChgToBy, p_Sta, m_Presets.m_Author );
 
						m_QNDM.appProcLog( ref uid, QNDefs.logTypeAdmin, ref msg );
					}
				}
			}

			return prUID;
		}

		//-------------------------------------------------------------------------
		private Rslt loadFX( XmlDocument p_XDoc ) {

			Rslt res;

			RsltString xVal;
			RsltXMLNode xNode;
			RsltXMLNode aNode;

			string txt;
			string val;

			int i, x;

			XmlNodeList nodeLst;

			/*
				<!ELEMENT Fix (RefProbRep*, Desc?, FixLst, AddInfo*, LogEntry*)>
					<!ATTLIST Fix
						Appl					CDATA #IMPLIED
						Assignd				CDATA #IMPLIED
						DateTime			NMTOKEN #REQUIRED
						DateTimeFix		NMTOKEN #IMPLIED
						DateTimeShip	NMTOKEN #IMPLIED
						Fctn					CDATA #IMPLIED
						FixStat				(as|at|bd|cl|ct|es|ev|fx|qr|qt|re|rv|sh|tf|ts|wf) "as"
						LastMod				NMTOKEN #IMPLIED
						LastModBy			CDATA #IMPLIED
						Lock					NMTOKEN #IMPLIED
						PlanRel				NMTOKEN #IMPLIED
						ProbRel				NMTOKEN #IMPLIED
						ShipRel				NMTOKEN #IMPLIED
						Title					CDATA #REQUIRED
						UID						NMTOKEN #IMPLIED
					>
			*/

			//res = reset4Load();

			res = new Rslt( true );

			nodeLst = p_XDoc.SelectNodes( "/Fix" );

			if( 1 != nodeLst.Count ) {

				m_Logger.write2Log( "Top node 'Fix' not found." );
				res.setInError( m_QNphrase.errInvXML );
			}
			else {

				xNode = nodeLst.Item( 0 );

				m_FxUid = xNode.UID;

				xVal = xNode.getAttrValFromHtml( "Appl" );
				txtAppl.Text = xVal.theString;

				xVal = xNode.getAttrValFromHtml( "Assignd" );

				if( xVal.isOK() ) {
	  
					txtAssgn.Text = xVal.theString;

					xVal = xNode.getAttrVal( "DateTime" );
				}
							
				if( xVal.isOK() ) {

					val = BTools.getDateFromISODateTime( xVal.theString );   					  
					txtOpenDate.Text = val;
					val = BTools.getTimeFromISODateTime( xVal.theString );   
					txtOpenTime.Text = val;

					xVal = xNode.getAttrVal( "DateTimeFix" );
					val = BTools.getDateFromISODateTime( xVal.theString );   					  
					txtFixDate.Text = val;
					val = BTools.getTimeFromISODateTime( xVal.theString );   
					txtFixTime.Text = val;

					/*xVal = xNode.getAttrVal( "DateTimeShip" );
					val = BTools.getDateFromISODateTime( xVal.theString );   					  
					txtShipDate.Text = val;
					val = BTools.getTimeFromISODateTime( xVal.theString );   
					txtShipTime.Text = val; */

					xVal = xNode.getAttrValFromHtml( "Fctn" );
					txtFctn.Text = xVal.theString;

					xVal = xNode.getAttrValFromHtml( "FixStat" );
				}
				
				if( xVal.isOK() ) {
					
					m_FxStat = xVal.theString;
					xVal = m_Presets.m_FixStatLst.getLabelByVal( m_FxStat );
					txtStatus.Text = xVal.theString;
				
					/*
					xVal = xNode.getAttrValFromHtml( "PlanRel" );
					txtTrgtRelease.Text = xVal.theString; */

					xVal = xNode.getAttrValFromHtml( "ProbRel" );
					txtRelease.Text = xVal.theString;

					/*xVal = xNode.getAttrValFromHtml( "ShipRel" );
					txtReleaseShpd.Text = xVal.theString;*/

					xVal = xNode.getAttrValFromHtml( "Title" );
				}

				if( xVal.isOK() ) {

					txtTitle.Text = xVal.theString;

					/*
						<!ELEMENT RefProbRep (EMPTY)>
							<!ATTLIST RefProbRep
								Title		CDATA #REQUIRED
								RefUID	NMTOKEN #REQUIRED
								UID			NMTOKEN #IMPLIED
							>
					*/

					m_TRLst.loadYSDown( xNode, lstTR );
				}

				if( xVal.isOK() ) {

					aNode = xNode.getSubNode( "Desc" );

					if( aNode.isOK() ) {

						m_DescUid = aNode.UID;
						txtDesc.Text = aNode.textFromHtml;
					}
				}

				if( xVal.isOK() ) {

					aNode = xNode.getSubNode( "TestReq" );

					if( aNode.isOK() ) {

						m_ReqUid = aNode.UID;
						txtTestReqs.Text = aNode.textFromHtml;
					}
				}

				if( xVal.isOK() ) {

					aNode = xNode.getSubNode( "InterRel" );

					if( aNode.isOK() ) {

						m_IRUid = aNode.UID;
						txtInter.Text = aNode.textFromHtml;
					}
				}

				if( xVal.isOK() ) {

					/*
					<!ELEMENT FixLst (FixEntry*)>
						<!ATTLIST FixLst
							UID				NMTOKEN #IMPLIED
						>

						<!ELEMENT FixEntry (EMPTY)>
							<!ATTLIST FixEntry
								DateTime	NMTOKEN #REQUIRED
								Name			NMTOKEN #REQUIRED
								Path			NMTOKEN #IMPLIED
								Rel				NMTOKEN #IMPLIED
								SrcSrv		NMTOKEN #IMPLIED
								UID				NMTOKEN #IMPLIED
							>
					*/

					nodeLst = xNode.m_xNode.SelectNodes( "./FixLst" );

					x = nodeLst.Count; 

					if( x == 1 ) {

						aNode = nodeLst.Item( 0 );

						m_FxLstUid = aNode.UID;

						nodeLst = aNode.m_xNode.SelectNodes( "./FixEntry" );

						FixSrcInfo fixEntry;

						x = nodeLst.Count; 

						for( i = 0; i < x; i++ ) {

							aNode = nodeLst.Item( i );

							xVal = aNode.getAttrValFromHtml( "Name" );

							fixEntry = new FixSrcInfo( xVal );

							xVal = aNode.getAttrVal( "DateTime" );
							fixEntry.m_DateTime = xVal;

							xVal = aNode.getAttrValFromHtml( "Path" );
							fixEntry.m_Path = xVal;

							xVal = aNode.getAttrValFromHtml( "Rel" );
							fixEntry.m_Rel = xVal;

							xVal = aNode.getAttrValFromHtml( "SrcSrv" );
							fixEntry.m_Server = xVal;

							xVal = aNode.getAttrVal( "UID" );
							fixEntry.UID = xVal;
							
							m_FixSrcLst.Add( fixEntry );

							// visible entry
							txt = fixEntry.m_Path;

							if( !( txt.EndsWith( "\\" ) ) && !( txt.EndsWith( "/" ) ) ) {

								txt	+= "\\";
							}
								
							txt	+= fixEntry.Title;

							txt += "; V" + fixEntry.m_Rel;

							txt += "; " + fixEntry.m_DateTime;

							lstFixSrc.Items.Add( txt );
						}
					}
				}
			
				if( xVal.notOK() ) {

					res.setRsltStat( xVal );
				}

			}

			if( res.notOK() ) {

				res.addRsltAddInfo( p_XDoc.OuterXml );
				res.addRsltAddInfo( "Failed to load TC." );
			}

			return res;
		}
		
		//-------------------------------------------------------------------------
		private void loadFXloader() {

			Rslt res = new Rslt();

			XMLDBNode xDBNode;

			try {

				reset();

				xDBNode = m_xDB.getXMLsubTree( ref m_loadUID );

//xDBNode.m_xDoc.Save( "FixDocTst.xml" );

				res.setRsltStat( xDBNode );

				if( res.isOK() ) {

					res = loadFX( xDBNode.m_xDoc );
				}

				if( res.notOK() ) {

					string msg =  m_QNphrase.errLoadFailed;
					handleErr( res, msg );
				}
				else {

					setAppStat( AppStat.OK );

					m_FXLoaded = true;

					setButStat( );

					addLog( String.Format( m_QNphrase.msgLoaded, txtTitle.Text ) );
				}
			}
			catch( Exception e ) {
		
				handleExcp( e );
			}
		}

		#endregion

		#region Event Handling

		// ---------------------------------------------------------
		private void menuExit_Click(object sender, System.EventArgs e) {
		
			setAppStat( AppStat.Proc );

			Close();
		}

		// ---------------------------------------------------------
		private void menuSave_Click(object sender, System.EventArgs e) {
		
			Rslt res = new Rslt();

			try {
		
				setAppStat( AppStat.Proc );

				res = saveFix( ref m_FxStat );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}	
			
			handleErrStat( res, "Saving Fix failed." );
		}

		// ---------------------------------------------------------
		private void menuOpen_Click(object sender, System.EventArgs e) {
		
			try {
		
				setAppStat( AppStat.Proc );

				frmFXSel dialFXSel = new frmFXSel( m_xDB, true, m_Presets, m_Presets.m_Author, m_FXSelPresets );

				handleSelDial( ref dialFXSel );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}	
		}

		// ---------------------------------
		private void menuAbout_Click(object sender, System.EventArgs e) {
					string title;
			string msg;

			setAppStat( AppStat.Proc );

			title = String.Format( m_QNphrase.msgAbout, m_QNphrase.lblFixMgr );

			msg = m_QNTools.getAboutInfoBlock();
			
			MessageBox.Show( msg, title, MessageBoxButtons.OK );	

			setAppStat( AppStat.OK );
		}
		
		// ---------------------------------
		private void ctxtShowVSS_Click(object sender, System.EventArgs e) {
		
			int i = lstFixSrc.SelectedIndex;

			if( i > -1 ) {

				string arg;
				string pth;

				FixSrcInfo fixSrc;

				setAppStat( AppStat.Proc );

				fixSrc = m_FixSrcLst[ i ];

				pth = fixSrc.m_Path;

				i = pth.LastIndexOf( "/" );

				if( i == (pth.Length -1) ) {

					pth = pth.Remove( i, 1 );
				}

				//item += entry[1];

				System.Diagnostics.Process proc = new System.Diagnostics.Process();

				proc.EnableRaisingEvents = false;

				//SSEXP -s\\Office\Source -dPowerpoint

				proc.StartInfo.FileName = "SSEXP.EXE";

				arg = " -p\"" + pth + "\"";

				proc.StartInfo.Arguments = arg;
				proc.Start();

				setAppStat( AppStat.OK );
			}
	}

		// ---------------------------------
		private void ctxtRemove_Click(object sender, System.EventArgs e) {

			setAppStat( AppStat.Proc );

			int i = lstFixSrc.SelectedIndex;

			if( i > -1 ) {

				lstFixSrc.Items.RemoveAt( i );

				m_FixSrcLst.RemoveAt( i );
			}

			setAppStat( AppStat.OK );
		}

		// ---------------------------------
		private void ctxtMenuSrcLst_Popup(object sender, System.EventArgs e) {

			setAppStat( AppStat.Proc );

			if( lstFixSrc.SelectedIndex < 0 ) {

				ctxtRemove.Enabled = false;
				//ctxtShowVSS.Visible = false;
			}
			else {

				ctxtRemove.Enabled = true;
				//ctxtShowVSS.Visible = true;
			}

			if( m_FXLoaded ) {

				ctxtAddSrc.Enabled = true;
			}
			else {

				ctxtAddSrc.Enabled = false;
			}
			
			setAppStat( AppStat.OK );
		}

		// ---------------------------------
		private void ctxtLogEntry_Click(object sender, System.EventArgs e) {

			string msg;

			setAppStat( AppStat.Proc );

			msg = m_QNTools.getComboSelVal( ref  comboLog );

			MessageBox.Show( msg, m_QNphrase.lblLogEntry, MessageBoxButtons.OK );	

			setAppStat( AppStat.OK );
		}


		// ---------------------------------
		private void ctxtMenuPR_Popup(object sender, System.EventArgs e) {
		
			setAppStat( AppStat.Proc );

			if( lstTR.SelectedIndex < 0 ) {

				ctxtViewPR.Visible = false;
			}
			else {

				ctxtViewPR.Visible = true;
			}

			setAppStat( AppStat.OK );
		}

		// ---------------------------------
		private void ctxtViewPR_Click(object sender, System.EventArgs e) {
		
			int i = lstTR.SelectedIndex;

			if( i > -1 ) {

				Ref2Doc refPR;
				
				string UID;

				setAppStat( AppStat.Proc );

				refPR = m_TRLst[ i ];
				UID = refPR.RefUID;

				if( UID.Length < 1 ) {

					MessageBox.Show( m_QNphrase.msgNoID4PR, m_QNphrase.lblNotice, MessageBoxButtons.OK, MessageBoxIcon.Exclamation );

					setAppStat( AppStat.OK );
				}
				else {

					string arg;

					System.Diagnostics.Process proc = new System.Diagnostics.Process();

					proc.EnableRaisingEvents = false;

					proc.StartInfo.FileName = m_Presets.m_WebExp;

					/* "http://localhost:8080/piQa/index.jsp?QNA=ViewProb&UID=11T2VT845P11111WSU136KI1111" */

					arg = m_Presets.m_QNWebPth;

					arg += "VQANavDoc?QNA=ViewProb&UID=" + UID;

					proc.StartInfo.Arguments = arg;
					proc.Start();

					setAppStat( AppStat.OK );
				}
			}
		}

		// ---------------------------------
		private void ctxtAddSrc_Click(object sender, System.EventArgs e) {
		
			try {

				setAppStat( AppStat.Proc );
				//frmVSSSel dialVSSSel = new frmVSSSel( m_Presets.m_VSSDBIniPath, txtAssgn.Text );
				//handleVSSSelDial( ref dialVSSSel );

				frmFixDesc dialFixDesc = new frmFixDesc( ref m_Presets );
				handleFixDescDial( ref dialFixDesc );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}	
		}
	
		// -------------------------------
		private void frmFixer_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
		
			string str;

			str = e.ToString();
		}

		// -------------------------------
		private void butAction_Click(object sender, System.EventArgs e) {

			Rslt res;
		
			setAppStat( AppStat.Proc );

			res = nextFixStat( );

			handleErrStat( res, "Failed to set Fix status." );
		}

		// -------------------------------
		private void txtDesc_DoubleClick(object sender, System.EventArgs e) {
		
			handleTxtPop( sender, lblFixDesc.Text );
		}

		// -------------------------------
		private void menuDocu_Click(object sender, System.EventArgs e) {
					
			try {

				setAppStat( AppStat.Proc );

				System.Diagnostics.Process proc = new System.Diagnostics.Process();

				proc.EnableRaisingEvents = false;

				proc.StartInfo.FileName = QNDefs.manQN;

				proc.Start();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
	
				handleExcp( excp );
			}
		}

		// -------------------------------
		private void butAction_MouseEnter(object sender, System.EventArgs e) {
		
			butAction.BackColor = m_Presets.m_ClrButHigh;
		}

		// -------------------------------
		private void butAction_MouseLeave(object sender, System.EventArgs e) {
		
			butAction.BackColor = m_Presets.m_ClrButBck;
		}

		// -------------------------------
		private void menuPrint_Click(object sender, System.EventArgs e) {
		
			string title;

			Rslt res = new Rslt( true );

			setAppStat( AppStat.Proc );

			RsltXMLNode xNode = bldFXdoc();

			string xsltName = QNDefs.xlsFixDoc + "_" + m_QNphrase.m_Loc + ".xsl";

			if( res.checkRslt( xNode ) ) {

				title = m_QNphrase.lblFix + " '" + txtTitle.Text + "'";

				res = m_GUIservice.printXDoc( xNode.m_xDoc, ref xsltName, ref title );
			}

			if( res.notOK() ) {

				handleErr( res, m_Presets.m_QNphrase.errPrintFailed );
			}
			else {

				setAppStat( AppStat.OK );
			}
		}

		#endregion

	}

	#region FixSrcInfo

	// -------------------------------------------------------------------------
	/// <summary>
	/// 
	/// </summary>
	public class FixSrcInfo : BaseContainer	{

		// path, name, rel, date, time, server, uid

		public string m_Path;
		public string m_Rel;
		public string m_DateTime;
		public string m_Server;

		// ------------------------
		/// <summary>
		/// 
		/// </summary>
		/// <param name="p_Title"></param>
		/// <param name="p_RefUID"></param>
		/// <param name="p_UID"></param>
		public FixSrcInfo( string p_Title )
			: base( p_Title ) {
			
			init();
		}

		// ------------------------
		/// <summary>
		/// 
		/// </summary>
		/// <param name="p_UID"></param>
		/// <param name="p_Title"></param>
		public FixSrcInfo( string p_UID, string p_Title )
			: base( p_UID, p_Title ) {
			
			init();
		}

		// ------------------------
		private void init() {

			m_Path = "";
			m_Rel = "";
			m_DateTime = "";
			m_Server = "";
		}
	}

	// ---------------------------------------------------
	public class FixSrcInfoLst : BaseContLst {
			
		/// <summary>
		/// 
		/// </summary>
		public FixSrcInfoLst() 
			: base() {

		}

		// -------------------------
		/// <summary>
		/// 
		/// </summary>
		new public FixSrcInfo this[ int p_index ] {

			get {

				FixSrcInfo obj;

				obj = (FixSrcInfo)base[ p_index ];

				return obj;			
			}

			set {

				base[ p_index ] = value;
			}
		}

/*

		// -------------------------
		public int Add( FixSrcInfo p_FixSrcInfo ) {

			return base.Add( p_FixSrcInfo );
		}

how do one hide this ??????
		// -------------------------
		new private int Add( object p_FixSrcInfo ) {

			return base.Add( p_FixSrcInfo );
		}
		

*/		
		// -------------------------
		private int Add( string[] p_lst ) {

			Exception excp = new Exception( "Invalid data 'string[]'" );
			
			throw( excp );

			return 0;
		}


	}

	#endregion

}
