//---------------------------------------------------------
// QA Navigator suite
// Copyright  2003,2004 Ronald D. Grindle
//---------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using QN.Basics;

namespace QN.TCEdit
{
	/// <summary>
	/// QA Navigator suite
	/// Copyright  2003,2004 Ronald D. Grindle
	/// 
	/// QA Navigator requirment source dialog
	/// </summary>
	public class frmReqSrc : System.Windows.Forms.Form
	{

		private QNphrase m_QNphrase;
		private QNpresets m_Presets;

		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.Label lblLoc;
		public System.Windows.Forms.TextBox txtTitle;
		public System.Windows.Forms.TextBox txtLoc;
		private System.Windows.Forms.Button butOK;
		private System.Windows.Forms.Button butCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmReqSrc( ref QNpresets p_Presets )
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			m_Presets = p_Presets;

			m_QNphrase = m_Presets.m_QNphrase;
		frmReqSel.CheckForIllegalCrossThreadCalls = false;
			setClrs();

			setLabels();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( frmReqSrc ) );
            this.lblTitle = new System.Windows.Forms.Label();
            this.lblLoc = new System.Windows.Forms.Label();
            this.txtTitle = new System.Windows.Forms.TextBox();
            this.txtLoc = new System.Windows.Forms.TextBox();
            this.butOK = new System.Windows.Forms.Button();
            this.butCancel = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // lblTitle
            // 
            this.lblTitle.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTitle.Location = new System.Drawing.Point( 10, 12 );
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size( 96, 23 );
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "Title";
            this.lblTitle.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblLoc
            // 
            this.lblLoc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblLoc.Location = new System.Drawing.Point( 10, 46 );
            this.lblLoc.Name = "lblLoc";
            this.lblLoc.Size = new System.Drawing.Size( 96, 23 );
            this.lblLoc.TabIndex = 1;
            this.lblLoc.Text = "Location";
            this.lblLoc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTitle
            // 
            this.txtTitle.Location = new System.Drawing.Point( 110, 12 );
            this.txtTitle.Name = "txtTitle";
            this.txtTitle.Size = new System.Drawing.Size( 581, 22 );
            this.txtTitle.TabIndex = 2;
            // 
            // txtLoc
            // 
            this.txtLoc.Location = new System.Drawing.Point( 110, 46 );
            this.txtLoc.Name = "txtLoc";
            this.txtLoc.Size = new System.Drawing.Size( 581, 22 );
            this.txtLoc.TabIndex = 3;
            // 
            // butOK
            // 
            this.butOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.butOK.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butOK.Location = new System.Drawing.Point( 470, 78 );
            this.butOK.Name = "butOK";
            this.butOK.Size = new System.Drawing.Size( 106, 28 );
            this.butOK.TabIndex = 4;
            this.butOK.Text = "OK";
            this.butOK.MouseLeave += new System.EventHandler( this.butOK_MouseLeave );
            this.butOK.Click += new System.EventHandler( this.butOK_Click );
            this.butOK.MouseEnter += new System.EventHandler( this.butOK_MouseEnter );
            // 
            // butCancel
            // 
            this.butCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.butCancel.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butCancel.Location = new System.Drawing.Point( 586, 78 );
            this.butCancel.Name = "butCancel";
            this.butCancel.Size = new System.Drawing.Size( 105, 28 );
            this.butCancel.TabIndex = 5;
            this.butCancel.Text = "Cancel";
            this.butCancel.MouseLeave += new System.EventHandler( this.butCancel_MouseLeave );
            this.butCancel.MouseEnter += new System.EventHandler( this.butCancel_MouseEnter );
            // 
            // frmReqSrc
            // 
            this.AcceptButton = this.butOK;
            this.AutoScaleBaseSize = new System.Drawing.Size( 6, 15 );
            this.CancelButton = this.butCancel;
            this.ClientSize = new System.Drawing.Size( 712, 115 );
            this.Controls.Add( this.butCancel );
            this.Controls.Add( this.butOK );
            this.Controls.Add( this.txtLoc );
            this.Controls.Add( this.txtTitle );
            this.Controls.Add( this.lblLoc );
            this.Controls.Add( this.lblTitle );
            this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
            this.MaximizeBox = false;
            this.MaximumSize = new System.Drawing.Size( 720, 155 );
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size( 720, 155 );
            this.Name = "frmReqSrc";
            this.Text = "frmReqSrc";
            this.ResumeLayout( false );
            this.PerformLayout();

		}
		#endregion

		//-------------------------------------------------------------------------
		private void setClrs() {

			this.BackColor = m_Presets.m_ClrPnlBck;		
			this.ForeColor = m_Presets.m_ClrPnlFor;
				
			butCancel.BackColor = m_Presets.m_ClrButBck;
			butCancel.ForeColor = m_Presets.m_ClrPnlFor;

			butOK.BackColor = m_Presets.m_ClrButBck;
			butOK.ForeColor = m_Presets.m_ClrPnlFor;

			txtLoc.BackColor = m_Presets.m_ClrTxtBck;
			txtTitle.BackColor = m_Presets.m_ClrTxtBck;
			
		}

		//-------------------------------------------------------------------------
		private void setLabels() {

			Text = m_QNphrase.lblReqSrcDial;

			butOK.Text = m_QNphrase.blblOK;
			butCancel.Text = m_QNphrase.blblCancel;

			lblLoc.Text = m_QNphrase.lblLoc;
			lblTitle.Text =  m_QNphrase.lblTitle;
		}

		private void butOK_Click(object sender, System.EventArgs e) {
		
			Close();
		}

		private void butOK_MouseEnter(object sender, System.EventArgs e) {
		
			butOK.BackColor = m_Presets.m_ClrButHigh;
		}

		private void butOK_MouseLeave(object sender, System.EventArgs e) {
		
			butOK.BackColor = m_Presets.m_ClrButBck;
		}

		private void butCancel_MouseEnter(object sender, System.EventArgs e) {
		
			butCancel.BackColor = m_Presets.m_ClrButHigh;
		}

		private void butCancel_MouseLeave(object sender, System.EventArgs e) {
		
			butCancel.BackColor = m_Presets.m_ClrButBck;
		}
	}
}
