<?xml version='1.0'?>
<!-- Stylesheet for a problem report -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>

	<title>
		<xsl:text disable-output-escaping="yes">QA Navigator - Fix Dokument '</xsl:text>
		<xsl:value-of disable-output-escaping="yes" select="Fix/@Title"/>
		<xsl:text disable-output-escaping="yes">'</xsl:text>
	</title>

	<style>

	table { 
		background-color: #FFFFFF;
		empty-cells:show; 
		margin: 4px;
		border:3px grey;
		border-style: ridge;
		border-collapse: collapse 
	}

	td { 
		border:1px black;
		padding: 4px;
		border-style: solid;
		vertical-align: middle;
	}
	</style>

	<link rel="stylesheet" type="text/css" href="QNStyle.css"/>

		<xsl:apply-templates select="Fix/Script"/>
	</head>
	<body class="work">
		<xsl:apply-templates select="Fix"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Fix">

	<h2 style="margin-left=6px;">L&ouml;sung</h2>

	<table width="95%">
		<tr>
			<td><b><xsl:value-of disable-output-escaping="yes" select="./@Title" /></b></td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>Zugeordnet</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Assignd" /></td>
		</tr>
		<tr>
			<td width="120px"><b>Datum</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>
		<tr>
			<td width="120px"><b>Status</b></td>
			<td><xsl:apply-templates select="./@FixStat"/></td>
		</tr>
	</table>
	
	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<table width="95%">
		<tr>
			<td width="120px"><b>Anwendung</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td>
			<td width="80px"><b>Release</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ProbRel" /></td>
		</tr>
		<tr>
			<td width="120px"><b>Funktion</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td><b>Geplantes Release</b></td>
			<td><b>Fix-Datum</b></td>
			<td><b>Auslieferungsdatum</b></td>
			<td><b>Ausgeliefertes Release</b></td>
		</tr>
		<tr>
			<td><xsl:value-of disable-output-escaping="yes" select="./@PlanRel" /></td>
			<td><xsl:value-of select="substring-before( ./@DateTimeFix, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTimeFix, 'T' )"/></td>
			<td><xsl:value-of select="substring-before( ./@DateTimeShip, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTimeShip, 'T' )"/></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ShipRel" /></td>
		</tr>
	</table>

	<xsl:if test="RefProbRep">

		<xsl:call-template name="RefProbRep"/>
	</xsl:if>


	<!-- xsl:apply-templates select="./RefProbRep"/ -->

	<table width="95%">
		<tr><td><b>Problembeschreibung</b></td></tr>
		<tr><td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./Desc" /></td></tr>
	</table>
	
	<h4 style="margin-left=6px;">Fix Liste</h4>

	<xsl:apply-templates select="./FixLst"/>

	<xsl:if test="ProcLog">

		<h4 style="margin-left=6px;">Prozess-Logbuch</h4>
		<xsl:apply-templates select="./ProcLog"/>
	</xsl:if>

	<!-- SysConfigRef*, AddInfo* -->

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@FixStat">

	<xsl:choose > 
		<xsl:when test = ". = 'as'" > 
			<xsl:text>Zugeordnet</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'at'" > 
			<xsl:text>Zum Testen zugeordnet</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'bd'" > 
			<xsl:text>In Bau</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ct'" > 
			<xsl:text>Klient Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'cl'" > 
			<xsl:text>Abgeschlossen</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'es'" > 
			<xsl:text>In Sch&auml;tzung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ev'" > 
			<xsl:text>In Untersuchung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'fx'" > 
			<xsl:text>In Bearbeitung</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'qr'" > 
			<xsl:text>Bereit f&uuml;r Review</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'qt'" > 
			<xsl:text>Bereit f&uuml;r Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 're'" > 
			<xsl:text>Wiederer&ouml;ffnet</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rv'" > 
			<xsl:text>In Pr&uuml;fung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'sh'" > 
			<xsl:text>In Lieferung</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'tf'" > 
			<xsl:text>Test gescheitert</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ts'" > 
			<xsl:text>Im Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'wf'" > 
			<xsl:text>Auf andere L&ouml;sung wartend</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="RefProbRep">

	<table width="95%">
		<tr>
			<td width="140px"><b>Problem-Meldung</b></td>
		</tr>
		<xsl:for-each select="RefProbRep">
			<tr><td>
				<xsl:if test="string(./@RefUID)">
					<xsl:text disable-output-escaping="yes">&lt;a href=&quot;VQANavDoc?QNA=ViewProb&amp;UID=</xsl:text>
					<xsl:value-of select="./@RefUID"/>
					<xsl:text disable-output-escaping="yes">&quot; target=&quot;_blank&quot;&gt;</xsl:text>
				</xsl:if>
				<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
				<xsl:if test="string(./@RefUID)">
					<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
				</xsl:if>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="FixLst">

	<table width="95%">
		<tr>
			<td><b>Datei</b></td>
			<td><b>Release</b></td>
			<td><b>Datum</b></td>
			<td><b>DB</b></td>
		</tr>
		<xsl:for-each select="./FixEntry">
			<tr>
				<td><xsl:value-of disable-output-escaping="yes" select="./@Path"/>//<xsl:value-of disable-output-escaping="yes" select="./@Name"/></td>
				<td><xsl:value-of disable-output-escaping="yes" select="./@Rel"/></td>
				<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
				<td><xsl:value-of disable-output-escaping="yes" select="./@SrcSrv"/></td>
			</tr>
		</xsl:for-each>
	</table>

</xsl:template>


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="LogEntry">

	<table width="95%">
		<tr><td><xsl:value-of disable-output-escaping="yes" select="./@Title"/></td></tr>
		<tr><td>Autor: <xsl:value-of disable-output-escaping="yes" select="./@Author"/> Datum: <xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

	<table width="95%">
		<tr><td>Datum: <xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

</xsl:stylesheet>
 
